Bug 868087 - Multiple memcache key/value pairs are used to store metadata for account and containers
Multiple memcache key/value pairs are used to store metadata for account and ...
Status: CLOSED CURRENTRELEASE
Product: GlusterFS
Classification: Community
Component: object-storage (Show other bugs)
pre-release
x86_64 Linux
unspecified Severity medium
: ---
: ---
Assigned To: Peter Portante
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-10-19 00:13 EDT by Peter Portante
Modified: 2014-07-11 12:16 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-07-11 12:16:48 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Peter Portante 2012-10-19 00:13:20 EDT
Description of problem:

  Currently, three memcache key/value pairs are used to cache the metadata for
  accounts and containers.

  This is both a potential data integrity problem and a performance issue.

  The data integrity problem can arise from two actors setting the various
  keys to different sets of computed values, or a reader fetching a partial
  set before a writer updates one of the keys.

  It is a performance problem in that we have triple the network traffic
  hitting the memcache servers.

Version-Release number of selected component (if applicable):

  RHS 2.0

How reproducible:

  Readily

Steps to Reproduce:
1. Hook up wireshark
2. Observe traffic two and from a memcache server
3. Notice for a given Swift API GET on a container, three memcache GET
   operations are performed
  
Actual results:

  3 memcache GET operations performed per Swift API GET on a container/account

Expected results:

  1 memcache GET operation performed per Swift API GET

Additional info:
Comment 1 Peter Portante 2012-10-19 00:14:12 EDT
I'll take this as I am currently working on performance improvements in the module containing the code for this behavior.
Comment 2 Vijay Bellur 2012-11-03 07:37:27 EDT
CHANGE: http://review.gluster.org/4139 (object-storeage: refactor to use one memcache key) merged in master by Vijay Bellur (vbellur@redhat.com)

Note You need to log in before you can comment on or make changes to this bug.